import { config } = baiji.Controller;

class A extends Controller {
  constructor() {

  }

  @config({
    description: 'fdjklsfal',
    params:
    route: {  }
  })
  uploadFile(ctx) {
    ctx.files.images => [{}, {}];
  }
}

## 功能列表
+ [x] 内建文件上传支持
+ [x] `_method` => action
+ [x] beforeRespond 支持
+ [x] entity 语法优化
+ [x] 更便捷的 Context 集成，比如 ctx.entities.user
+ [x] 整体 async 化
+ [x] 添加 Service 类
+ [ ] 公共参数支持
+ [ ] parameters 引擎支持或者插件化
+ [ ] 自动生成 routes.json 到某一目录

let app = baiji()
app.context.entities = glue.load('./entities')

## 分层定义

#### Action

接口类，包含有一个接口的所有逻辑，配置和各个生命周期

checkPoint => 检查点概念

await onCheckPoint('before_params', ctx);
await onCheckPoint('after_params', ctx);

+ beforeParams 解析参数前
+ afterParams 解析参数后
+ beforeAction 方法执行前
+ beforeRespond Action 执行中，返回数据前
+ afterRespond  Action 执行中，返回数据后
+ afterAction 方法执行后
+ afterActionError / afterError / onError 报错处理



this.beforeRespond(ctx, next)

await ctx.respond()

ctx.app

app.context.models => ctx.models

baiji()

ctx.body

ctx.query

ctx.params
ctx.body
ctx.query
ctx.header

ovt.plugin('lodash')
ovt.plugin('validator')
ovt.plugin('xss')
ovt.plugin('baiji')

ctx.param('name')

### 文档

baiji


baiji
baiji-glue

ovt
ovt-plugin-xss
ovt-plugin-validator
ovt-plugin-lodash
ovt-plugin-baiji

baiji-entity

baiji-normalizer

baiji-swagger

ovt 没文档, baiji 没文档
entity 太麻烦 => model 生成
baiji-cli 一键生成项目


// 常见问题

如何上传文档
如何启动 session
如何配置缓存

[
  { name: 'name', type: '', description: '', default: '', params: [] }
]


```javascript
const { Controller, config } = require('baiji');

class UsersCtrl extends Controller {
  initConfig() {
    const { app, logger, services, entities } = this;

    return {
      signIn: {
        description: 'fjdslfds',
        params: ovt.object({
          name: ovt.string().required().desc('用户名称'),
          avatar: ovt.file().maxCount(1).required().desc('用户头像'),
          image_galleries: ovt.file({
            buffer: true,
            dest: '/'
          }).maxCount(9).required().desc('用户图集')
          // {
          //   filename,
          //   originalname,
          //   size,
          //   mimetype,
          //   path,
          //   buffer
          // }
        }),
        // upload: {
        //   fields: [{ name: 'avatar', maxCount: 1 }],
        //   dest: ....
        // }
        mock: {
          metadata: {},
          data: entities.user.example()
        },
        route: { verb: ['get', 'post'], path: '/fjdslfds' }
      }
    }
  }
}

app.context = {
  models: require('./models'),
  services: glue.autoload('./services'),
  entities: glue.autoload('./entities'),
  config,

}
```


```javascript
const schema = ovt.object({
  name: ovt.string(),
  age: ovt.string().default(18),
  idCard: ovt.when('age', { is: ovt.number().gte(18), then: ovt.string(), otherwise: fdsafd })
})

let result = ovt.validate(schema, { name: 'Felix' })

{
  errors
  value = { name: 'Felix', age: 18 }
}


ovt.string().trim().isLength({ min: 1, max: 10 }).padLeft('    ')


let query = db.users.where('id', '=', 1).where({ name: 'felix' }).whereIn('tag', [1,2,3])

query.where()


const entity = new Entity();


entity.expose('name', 'id', 'nickname');

entity.parse(model, { fields: 'name id child(name gender)' })
```


```
this.beforeAspect('some_logic_condition', 'fjsdklfs');
this.beforeAspect('auth_check', 'authCheck', { only: ['someAction'] });

async someAction(ctx) {
  // 300
  // logic 1

  conditionalLogic

  let hasAuthority = await ctx.services.users.hasAuthority();
  if (!hasAuthority) return;

  await this.aspect('auth_check', { model: article, ..... });
}

async someAction1(ctx) {
  // 300
  // logic 2

  conditionalLogic

}

async someAction2(ctx) {
  // 300
  // logic 3

  conditionalLogic
}

```
